## malamute 1.1.0+git20250625

=== debian/control ===
#
#    malamute - ZeroMQ Message Broker
#
#    Copyright (c) the Contributors as noted in the AUTHORS file.
#    This file is part of the Malamute Project.
#
#    This Source Code Form is subject to the terms of the Mozilla Public
#    License, v. 2.0. If a copy of the MPL was not distributed with this
#    file, You can obtain one at http://mozilla.org/MPL/2.0/.

Source:         malamute
Section:        net
Priority:       optional
Maintainer:     malamute Developers <zeromq-dev@lists.zeromq.org>
Standards-Version: 4.0.1.0
Build-Depends: debhelper-compat (= 12),
    pkgconf | pkg-config,
    libzmq3-dev,
    libczmq-dev,
    systemd-dev | systemd,
    dh-python <!nopython>,
    python3-all-dev <!nopython>, python3-cffi <!nopython>, python3-setuptools <!nopython>,
    asciidoc-base <!nodoc>, xmlto <!nodoc>,

Package: libmlm1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: malamute shared library
 This package contains shared library for malamute:
 zeromq message broker

Package: libmlm-dev
Architecture: any
Section: libdevel
Depends:
    ${misc:Depends},
    libzmq3-dev,
    libczmq-dev,
    libmlm1 (= ${binary:Version})
Description: malamute development tools
 This package contains development files for malamute:
 zeromq message broker

Package: malamute
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: runnable binaries from malamute
 Main package for malamute:
 zeromq message broker

Package: malamute-dbg
Architecture: any
Section: debug
Priority: optional
Depends:
    malamute (= ${binary:Version}),
    ${misc:Depends}
Description: malamute debugging symbols
 This package contains the debugging symbols for malamute:
 zeromq message broker.

Package: python3-malamute-cffi
Architecture: any
Section: python
Depends:
    libmlm1 (= ${binary:Version}),
    ${misc:Depends}, ${shlibs:Depends},
    ${python3:Depends}, python3-cffi,
Description: Python 3 CFFI bindings for malamute
 This package contains Python 3 CFFI bindings for malamute.
